// Client.java

public class Client {

  public static void main(String[] args) throws Exception {
    // Initialize the ORB.
    org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);
    // Locate a printer manager.
    Printer.PrinterManager manager = 
	Printer.PrinterManagerHelper.bind(orb, "PrinterManager");

   // Create Dynamic struct
    org.omg.CORBA.DynStruct info = orb.create_dyn_struct(Printer.StructTypeHelper.type());

    // Create our NameValuePair sequence (array)
    org.omg.CORBA.NameValuePair[] NVPair = new org.omg.CORBA.NameValuePair[3];

    // Create and initialize Dynamic Struct data as any's
    org.omg.CORBA.Any str_any = orb.create_any();
    str_any.insert_string("String");
    org.omg.CORBA.Any e_any = orb.create_any();
    Printer.EnumTypeHelper.insert(e_any, Printer.EnumType.second);
    org.omg.CORBA.Any fl_any = orb.create_any();
    fl_any.insert_float((float)864.50);

    NVPair[0] = new org.omg.CORBA.NameValuePair("str", str_any);
    NVPair[1] = new org.omg.CORBA.NameValuePair("e", e_any);
    NVPair[2] = new org.omg.CORBA.NameValuePair("fl", fl_any);

    // Initialize the Dynamic Struct
    info.set_members(NVPair);

    manager.printAny(info.to_any());

    manager.shutdown();
  }

}
