// File: CryptoServerInter.java

package Encryption;

import com.visigenic.vbroker.interceptor.*;
import com.visigenic.vbroker.IOP.*;
import com.visigenic.vbroker.GIOP.*;
import com.visigenic.vbroker.interceptor.ServerInterceptorPackage.*;
import org.omg.CORBA.*;
import org.omg.CORBA.portable.*;

public class CryptoServerInter extends Crypto implements ServerInterceptor
{
  public CryptoServerInter(com.visigenic.vbroker.orb.ORB orb)
  {
    super("ServerINT", orb);
  }

  public IOR locate(int req_id, byte[] object_key, Closure closure) 
  {
    interceptPrint("locate");
    return null;
  }

  public void locate_succeeded(int req_id, Closure closure) 
  {
    interceptPrint("locate_succeeded");
  }

  public void locate_forwarded(int req_id, IORHolder ior, Closure closure)
  {
    interceptPrint("locate_forwarded");
  }

  public IOR locate_failed(int req_id, byte[] object_key, Closure closure)
  {
    interceptPrint("locate_failed");
    return null;
  }

  public InputStream receive_request(RequestHeader request, 
				     ObjectHolder target, 
				     InputStream buf,
				     Closure closure) 
  {
    interceptPrint("receive_request");
    return decrypt(buf);
  }

  public void prepare_reply(RequestHeader request, 
			    ReplyHeaderHolder reply,
			    org.omg.CORBA.Object target,
			    Closure closure)
  {
    interceptPrint("prepare_reply");
  }

  public OutputStream send_reply(RequestHeader request,
				 ReplyHeader reply,
				 org.omg.CORBA.Object target,
				 OutputStream buf,
				 org.omg.CORBA.Environment env,
				 Closure closure)
  {
    interceptPrint("send_reply");
    if ((reply.reply_status.value() == ReplyStatusType._USER_EXCEPTION) ||
       (reply.reply_status.value() == ReplyStatusType._SYSTEM_EXCEPTION)) {
      // Don't encrypt an exception
      return null;
    } else {
      return encrypt(buf, ENCRYPTION_KEY_REPLY);
    }
  }

  public void send_reply_failed(RequestHeader request,
				ReplyHeader reply,
				org.omg.CORBA.Object target,
				org.omg.CORBA.Environment env,
				Closure closure)
  {
    interceptPrint("send_reply_failed");
  }
				 
  public void request_completed(RequestHeader request, 
				org.omg.CORBA.Object target,
				Closure closure)
  {
    interceptPrint("request_completed");
  }

  public void shutdown(ShutdownReason reason)
  {
    interceptPrint("shutdown");
  }

  public void exception_occurred(RequestHeader hdr,
				 org.omg.CORBA.Environment env,
				 Closure closure) 
  {
    interceptPrint("exception_occurred");
    if (env != null) {
      System.out.println(env.exception());
    }
  }
}
