// SampleServerInterceptor.java 

package sample;

import com.visigenic.vbroker.interceptor.*;
import com.visigenic.vbroker.IOP.*;
import com.visigenic.vbroker.GIOP.*;
import org.omg.CORBA.portable.*;

public class SampleServerInterceptor extends SampleInterceptor implements ServerInterceptor
{
    public SampleServerInterceptor()
    {
        super("ServINT");
    }

    public IOR locate(int req_id, byte[] object_key, Closure closure)
    {
        print("locate");
        return null;
    }

    public void locate_succeeded(int req_id, Closure closure)
    {
        print("locate_succeeded");
    }

    public void locate_forwarded(int req_id, IORHolder forward_ior, Closure closure)
    {
        print("locate_forwarded");
    }

    public IOR locate_failed(int req_id, byte[] object_key, Closure closure)
    {
        print("locate_failed");
        return null;
    }

    public InputStream receive_request(RequestHeader hdr, org.omg.CORBA.ObjectHolder target, InputStream buf, Closure closure)
    {
        print("receive_request");
        return null;
    }

    public void prepare_reply(RequestHeader hdr, ReplyHeaderHolder reply, org.omg.CORBA.Object target, Closure closure)
    {
        print("prepare_reply");
    }

    public org.omg.CORBA.portable.OutputStream send_reply(RequestHeader reqHdr, ReplyHeader hdr, org.omg.CORBA.Object target, OutputStream buf, org.omg.CORBA.Environment env, Closure closure)
    {
        print("send_reply");
        return null;
    }

    public void send_reply_failed(RequestHeader reqHdr, ReplyHeader replyHdr, org.omg.CORBA.Object target, org.omg.CORBA.Environment env, Closure closure)
    {
        print("send_reply_failed");
    }

    public void request_completed(RequestHeader reqHdr, org.omg.CORBA.Object target, Closure closure)
    {
        print("request_completed");
    }

    public void shutdown(com.visigenic.vbroker.interceptor.ServerInterceptorPackage.ShutdownReason reason)
    {
        print("shutdown");
    }

    public void exception_occurred(RequestHeader reqHdr, org.omg.CORBA.Environment env, Closure closure)
    {
        print("exception_occurred");
    }
}
