// TimerServerInterceptor.java

package timer;

import com.visigenic.vbroker.interceptor.*;
import com.visigenic.vbroker.IOP.*;
import com.visigenic.vbroker.GIOP.*;
import org.omg.CORBA.portable.*;

public class TimerServerInterceptor extends TimerInterceptor implements ServerInterceptor
{
    public IOR locate(int req_id, byte[] object_key, Closure closure)
    {
        closure.object = new TimerData();
        return null;
    }

    public void locate_succeeded(int req_id, Closure closure)
    {
        print("locate", null, closure.object);
    }

    public void locate_forwarded(int req_id, IORHolder forward_ior, Closure closure)
    {
        print("locate", null, closure.object);
    }

    public IOR locate_failed(int req_id, byte[] object_key, Closure closure)
    {
        print("locate", null, closure.object);
        return null;
    }

    public InputStream receive_request(RequestHeader hdr, org.omg.CORBA.ObjectHolder target, InputStream buf, Closure closure)
    {
        begin(closure, hdr.operation);
        return null;
    }

    public void prepare_reply(RequestHeader hdr, ReplyHeaderHolder reply, org.omg.CORBA.Object target, Closure closure)
    {
        delta(closure, "process time");
    }

    public org.omg.CORBA.portable.OutputStream send_reply(RequestHeader reqHdr, ReplyHeader hdr, org.omg.CORBA.Object target, OutputStream buf, org.omg.CORBA.Environment env, Closure closure)
    {
        delta(closure, "prepare response");
        return null;
    }

    public void send_reply_failed(RequestHeader reqHdr, ReplyHeader replyHdr, org.omg.CORBA.Object target, org.omg.CORBA.Environment env, Closure closure)
    {
        delta(closure, "send time");
    }

    public void request_completed(RequestHeader reqHdr, org.omg.CORBA.Object target, Closure closure)
    {
        delta(closure, "send time");
        complete(closure, "total call");
    }

    public void shutdown(com.visigenic.vbroker.interceptor.ServerInterceptorPackage.ShutdownReason reason)
    {
    }

    public void exception_occurred(RequestHeader reqHdr, org.omg.CORBA.Environment env, Closure closure)
    {
    }
}
