// AccountFinder.java


public class AccountFinder {

  private static void UsageHelper()
  {
    System.out.println("Unable to locate LocationService\n" +
       "   -Make sure the locserv process is running\n" +
       "   -Make sure you set the client's System Property\n" +
       "    ORBservices=\"com.visigenic.vbroker.ObjLocation\"");
  }

  public static void main(String[] args)
  {
    try {
      // Initialize the ORB.
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);
      // Initialize the BOA.
      org.omg.CORBA.BOA boa = orb.BOA_init();
      com.visigenic.vbroker.ObjLocation.Agent the_agent = null;

      try {
	org.omg.CORBA.Object obj = 
	  orb.resolve_initial_references("LocationService");
	if ((obj == null) ||
	    ((the_agent=com.visigenic.vbroker.ObjLocation.AgentHelper.narrow(obj)) == null)) {
	  UsageHelper();
	  System.exit(1);
	}
      } catch (org.omg.CORBA.ORBPackage.InvalidName e) {
	System.out.println("Not able to resolve references " +
			   "for LocationService");
	UsageHelper();
	System.exit(1);
      } catch (Exception e) {
	System.out.println("Caught exception: " + e);
	UsageHelper();
	System.exit(1);
      }
      
      org.omg.CORBA.Object[] accountRefs =
	the_agent.all_instances("IDL:Bank/AccountManager:1.0");
      System.out.println("Agent returned " + accountRefs.length +
			 " object references");
      for (int i=0; i < accountRefs.length; i++) {
	System.out.println("Stringified IOR for account #" + (i+1) + ":");
	System.out.println(orb.object_to_string(accountRefs[i]));
	System.out.println();
      }
    } catch (Exception e) {
      System.out.println("Caught exception: " + e);
      System.exit(1);
    }
  }
}
