// TypedServer.java

public class TypedServer {

  public static void main(String[] args) throws Exception {
    // Initialize the ORB.
    org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);

    // Add two typed object wrappers for AccountManager objects
    Bank.AccountManagerHelper.addServerObjectWrapperClass(orb, BankWrappers.SecureAccountManagerObjectWrapper.class);
    Bank.AccountManagerHelper.addServerObjectWrapperClass(orb, BankWrappers.CachingAccountManagerObjectWrapper.class);

    // Initialize the BOA.
    org.omg.CORBA.BOA boa = orb.BOA_init();
    // Create the account manager object.
    Bank.AccountManager manager = 
      new AccountManagerImpl("BankManager")._this();
    // Export the newly create object.
    boa.obj_is_ready(manager);
    System.out.println("AccountManager:BankManager is ready.");
    // Wait for incoming requests
    boa.impl_is_ready();
  }
}

