// ListClient.java

import java.io.*;
import java.util.*;

public class ListClient {

  public static void main(String[] args) throws Exception {
    org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null); 
    ListUtility lu = ListUtilityHelper.bind(orb); 
    {
      List list = new List("Hello", new List("World", null));
      System.out.println("list:    " + list);
      System.out.println("length:  " + lu.length(list));
      System.out.println("reverse: " + lu.reverse(list));
      System.out.println("sort:    " + lu.sort(list));
    }
    {
      List list = new List("this", new List("is", new List("a", new List("test", null))));
      System.out.println("list:    " + list);
      System.out.println("length:  " + lu.length(list));
      System.out.println("reverse: " + lu.reverse(list));
      System.out.println("sort:    " + lu.sort(list));
    }
    {
      // read in the contents of a file
      InputStream input = new FileInputStream("ListUtility.java");
      byte[] bytes = new byte[input.available()];
      input.read(bytes);
      String text = new String(bytes);
      List list = null;
      // break the input into tokens (ignoring white space and puctuation)
      StringTokenizer tokenizer = new StringTokenizer(text, " \n.;,/{}()");
      while(tokenizer.hasMoreTokens()) {
	list = new List(tokenizer.nextToken(), list);
      }
      System.out.println("list:    " + list);
      System.out.println("length:  " + lu.length(list));
      System.out.println("reverse: " + lu.reverse(list));
      System.out.println("sort:    " + lu.sort(list));
    }
  }

}
