// Client.java

import java.io.*;

public class Client {

  public static void main(String[] args) {
    // Initialize the ORB.
    org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, null);
    // Read the AccountManager's IOR from a file
    Bank.AccountManager manager = null;
    try {
      LineNumberReader input =
	new LineNumberReader(new FileReader("bank.ior"));
      org.omg.CORBA.Object object = orb.string_to_object(input.readLine());
      manager =	Bank.AccountManagerHelper.narrow(object);
    }
    catch(java.io.IOException e) {
      System.out.println("Exception: " + e);
      System.exit(1);
    }
    // use args[0] as the account name, or a default.
    String name = args.length > 0 ? args[0] : "Jack B. Quick";
    // Request the account manager to open a named account.
    Bank.Account account = manager.open(name);
      // Get the balance of the account.
    float balance = account.balance();
    // Print out the balance.
    System.out.println
      ("The balance in " + name + "'s account is $" + balance);
  }

}
